#dropper effects
execute as @a[scores={player=1..},tag=!onTrap] at @s if block ~ ~-1 ~ dropper run function single:trapdropper
tag @a[tag=onTrap] remove onTrap
execute as @a[scores={player=1..}] at @s if block ~ ~-1 ~ dropper run tag @s add onTrap

#soul sand
execute as @a[scores={player=1..}] at @s if block ~ ~-0.8 ~ soul_sand run effect give @s jump_boost 1 128 true
execute as @a[scores={player=1..}] at @s if block ~ ~-0.8 ~ soul_sand run effect give @s slowness 1 2 true
execute as @a[scores={player=1..},nbt={ActiveEffects:[{Id:8b}]}] at @s unless block ~ ~-0.8 ~ soul_sand run effect clear @s jump_boost
execute as @a[scores={player=1..},nbt={ActiveEffects:[{Id:2b}]}] at @s unless block ~ ~-0.8 ~ soul_sand run effect clear @s slowness

#talk to steve
execute at @e[tag=steve,type=villager] as @a[scores={talk=1},distance=..4] run tellraw @s [{"text":"Steve: ","color":"gold","bold":"true"},{"text":"I have a bad feeling about this... Mr. Winston and Alfred are already out of sight... I'm about to leave, I'm not getting paid for this.","color":"gold","bold":"false"}]
execute at @e[tag=steve,type=villager] as @a[scores={talk=1},distance=..4] run playsound entity.chicken.egg master @s ~ ~ ~ 1000
execute at @e[tag=steve,type=villager] as @a[scores={talk=1},distance=..4] run scoreboard players reset * talk

#villager particles
execute at @e[type=villager,tag=winston] run particle dust 1 0 1 1 ~ ~1 ~ 0.3 0.8 0.3 0 10 force @a
execute at @e[type=villager,tag=winston,team=!mob] run particle cloud ~ ~ ~ 0.3 0.1 0.3 0 10 force @a
execute at @e[type=villager,tag=alfred] run particle dust 1 0 1 1 ~ ~1 ~ 0.3 0.8 0.3 0 10 force @a
execute at @e[type=villager,tag=alfred,team=!mob] run particle cloud ~ ~ ~ 0.3 0.1 0.3 0 10 force @a

#illusioner particles
execute at @e[type=evoker,tag=illusioner] run particle dust 1 0 1 1 ~ ~2 ~ 0.4 0.1 0.4 0 20 force @a
execute at @e[type=evoker,tag=illusioner] run particle portal ~ ~2 ~ 0.3 0.1 0.3 0 10 force @a

#no going to rat king idle
execute as @a[scores={player=1..},x=743,y=4,z=-352,dx=8,dy=7,dz=10] at @s run tp @s ~ ~ ~-1

#start rat king second time+
execute unless entity @e[tag=controller,type=armor_stand,tag=specMode] if entity @e[tag=controller,type=armor_stand,tag=tried,tag=!won] if entity @a[scores={player=1..},x=742,y=0,z=-365,dx=10,dy=7,dz=25,nbt={OnGround:1b}] as @e[tag=controller,type=armor_stand] run function single:ratkingstart

#start rat king first time
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={timer=0}] if entity @a[scores={player=1..},x=742,y=0,z=-365,dx=10,dy=7,dz=25,nbt={OnGround:1b}] run scoreboard players reset * killRat
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={timer=0}] if entity @a[scores={player=1..},x=742,y=0,z=-365,dx=10,dy=7,dz=25,nbt={OnGround:1b}] as @a[scores={player=1..}] unless entity @s[x=742,y=0,z=-365,dx=10,dy=7,dz=25] run tp @s @r[scores={player=1..},x=742,y=0,z=-365,dx=10,dy=7,dz=25]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={timer=0}] if entity @a[scores={player=1..},x=742,y=0,z=-365,dx=10,dy=7,dz=25,nbt={OnGround:1b}] run tellraw @a [{"text":"[1/2] ","color":"gray","bold":"true"},{"text":"Alfred: ","color":"gold","bold":"true"},{"text":"HEEELLP! THE MURDERER GOT ME!!!","color":"gold","bold":"false"}]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={timer=0}] if entity @a[scores={player=1..},x=742,y=0,z=-365,dx=10,dy=7,dz=25,nbt={OnGround:1b}] as @a run playsound entity.chicken.egg master @s ~ ~ ~ 1000 
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={timer=0}] if entity @a[scores={player=1..},x=742,y=0,z=-365,dx=10,dy=7,dz=25,nbt={OnGround:1b}] run scoreboard players set @e[tag=controller,type=armor_stand] timer 1

execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={time=60}] run tellraw @a [{"text":"[2/2] ","color":"gray","bold":"true"},{"text":"Mr. Winston: ","color":"gold","bold":"true"},{"text":"I demand you to put me down this instant, you disgusting wretch! You're more hideous than that fat rat!","color":"gold","bold":"false"}]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={time=60}] as @a run playsound entity.chicken.egg master @s ~ ~ ~ 1000 

execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={time=200}] at @e[type=evoker,tag=illusioner] run playsound entity.illusioner.prepare_mirror master @a ~ ~ ~ 10 
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={time=200}] run team join mob @e[type=slime,tag=ratKing]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={time=200}] run team join mob @e[type=villager,tag=alfred]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={time=200}] run team join mob @e[type=villager,tag=winston]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={time=200}] run data merge entity @e[type=villager,tag=winston,limit=1] {NoGravity:0b,Motion:[0.4,0.4,0.8]}
execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={time=200}] run data merge entity @e[type=villager,tag=alfred,limit=1] {NoGravity:0b,Motion:[-0.4,0.4,0.8]}

execute if entity @e[tag=controller,type=armor_stand,tag=!tried,tag=!specMode,scores={time=300..}] as @e[type=slime,tag=ratKing] at @s unless entity @e[type=villager,tag=winston,distance=..1] run tp @e[type=villager,tag=winston,limit=1] @e[type=slime,tag=ratKing,limit=1]

execute unless entity @e[tag=controller,type=armor_stand,tag=tried,tag=specMode] if entity @e[tag=controller,type=armor_stand,scores={time=200..}] as @e[type=slime,tag=ratKing] at @s if entity @e[type=villager,tag=winston,distance=..1] run function single:ratkingstart

#rat king boss
execute as @e[tag=controller,type=armor_stand,tag=specMode] run function multiple:ratking

#end scene/leave basement
execute if entity @e[tag=controller,type=armor_stand,tag=won] as @a[scores={player=1..},limit=1,x=746,y=17,z=-623,dx=2,dy=1,dz=2] run function single:day5pt24