execute if entity @e[tag=controller,type=armor_stand,tag=!tried] run scoreboard players set @e[tag=controller] timer 0
execute if entity @e[tag=controller,type=armor_stand,tag=!tried] run scoreboard players reset @e[tag=controller] time
execute if entity @e[tag=controller,type=armor_stand,tag=!tried] run scoreboard players reset * talk
execute if entity @e[tag=controller,type=armor_stand,tag=!tried] run kill @e[type=villager,tag=winston]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried] run kill @e[type=villager,tag=alfred]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried] run tp @e[type=villager,tag=steve] @e[tag=controller,type=armor_stand,limit=1]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried] at @e[type=slime,tag=ratking] run playsound entity.generic.eat master @a ~ ~ ~ 100
execute if entity @e[tag=controller,type=armor_stand,tag=!tried] run tellraw @a [{"text":"Mr. Winston was eaten by The Rat King","color":"white"}]
execute if entity @e[tag=controller,type=armor_stand,tag=!tried] run tellraw @a [{"text":"Alfred was eaten by The Rat King","color":"white"}]

data merge entity @e[type=slime,tag=ratKing,limit=1] {Size:19}
team join mob @e[tag=ratKing,type=slime]

tag @e[tag=controller,tag=!tried,type=armor_stand] add tried

scoreboard objectives add ratKing dummy
scoreboard players set @e[type=slime,tag=ratKing] ratKing 1
scoreboard players set @a[scores={player=1..}] ratKing 1
scoreboard objectives add move dummy
scoreboard players set @e[type=slime,tag=ratKing] move 1
scoreboard objectives add ratKingCount dummy
scoreboard players set @e[type=armor_stand,tag=controller] ratKingCount 0
execute as @a[scores={player=1..}] run scoreboard players add @e[type=armor_stand,tag=controller] ratKingCount 1
scoreboard objectives add ratKingT dummy
scoreboard players set @e[type=slime,tag=ratKing] ratKingT 0
scoreboard objectives add dispenserT dummy
scoreboard objectives add killHusk minecraft.killed:minecraft.husk
scoreboard objectives add killFake minecraft.killed:minecraft.stray
scoreboard objectives add killRat minecraft.killed:minecraft.silverfish
scoreboard objectives add countHusk dummy
scoreboard objectives add waitT dummy
scoreboard players add @e[type=slime,tag=ratKing] waitT 0

scoreboard players reset @a music

tag @e[tag=controller] add specMode

title @a times 20 80 20 
execute as @a at @s run playsound entity.ender_dragon.growl master @s ~ ~ ~ 1000 0.5
title @a title [{"text":"Boss Battle","color":"dark_purple","bold":"true"}]
title @a subtitle [{"text":"The Rat King","color":"light_purple","bold":"true"}]

execute as @a[scores={player=1..}] unless entity @s[x=742,y=0,z=-365,dx=10,dy=7,dz=25] run tp @s 747 4 -361 0 0

tag @e[type=slime,tag=ratKing] add move1

#illusioner
execute at @e[type=evoker,tag=illusioner] run particle witch ~ ~1 ~ 0.4 0.6 0.4 0 100 force @a
execute at @e[type=evoker,tag=illusioner] run playsound entity.illusioner.mirror_move master @a ~ ~ ~ 7
tp @e[type=evoker,tag=illusioner] @e[tag=controller,type=armor_stand,limit=1]
kill @e[type=evoker,tag=illusioner]

#close shop
clone 745 14 -615 745 14 -615 739 5 -613
fill 737 4 -611 737 4 -615 spruce_slab[type=top] replace air

#summon skeletons
summon skeleton 747 4 -475 {Tags:["ratKingM"],Health:1,Attributes:[{Name:"generic.attackDamage",Base:0.0},{Name:"generic.maxHealth",Base:1.0},{Name:"generic.followRange",Base:4.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.knockbackResistance",Base:1.0}],HandItems:[{id:"minecraft:bow",tag:{Enchantments:[{id:punch,lvl:1}]},Count:1b},{}]}
summon skeleton 747 4 -481 {Tags:["ratKingM"],Health:1,Attributes:[{Name:"generic.attackDamage",Base:0.0},{Name:"generic.maxHealth",Base:1.0},{Name:"generic.followRange",Base:4.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.knockbackResistance",Base:1.0}],HandItems:[{id:"minecraft:bow",tag:{Enchantments:[{id:punch,lvl:2}]},Count:1b},{}]}
summon skeleton 747 4 -487 {Tags:["ratKingM"],Health:1,Attributes:[{Name:"generic.attackDamage",Base:0.0},{Name:"generic.maxHealth",Base:1.0},{Name:"generic.followRange",Base:4.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.knockbackResistance",Base:1.0}],HandItems:[{id:"minecraft:bow",tag:{Enchantments:[{id:punch,lvl:1}]},Count:1b},{}]}
team join mob @e[type=skeleton,tag=ratKingM]

#summon silverfish
#soul sand
#execute as @a[scores={player=1..},limit=2] run summon silverfish 751 3 -469 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:2.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
#execute as @a[scores={player=1..},limit=2] run summon silverfish 744 3 -472 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:2.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
#execute as @a[scores={player=1..},limit=2] run summon silverfish 747 3 -478 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:2.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
#execute as @a[scores={player=1..},limit=2] run summon silverfish 749 3 -486 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:2.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
#execute as @a[scores={player=1..},limit=2] run summon silverfish 744 3 -496 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:2.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
#lava traps
execute as @a[scores={player=1..},limit=2] run summon silverfish 747 4 -517 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:2.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=2] run summon silverfish 749 4 -532 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:2.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
#box parkour
execute as @a[scores={player=1..},limit=2] run summon silverfish 745 4 -549 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:3.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=1] run summon silverfish 751 4 -551 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:3.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=2] run summon silverfish 747 4 -564 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:3.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=1] run summon silverfish 742 4 -560 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:3.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=1] run summon silverfish 744 4 -577 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:3.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=1] run summon silverfish 747 4 -570 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:3.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=2] run summon silverfish 752 4 -580 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:3.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
#final section
execute as @a[scores={player=1..},limit=2] run summon silverfish 748 4 -590 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:4.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=1] run summon silverfish 750 4 -597 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:4.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=1] run summon silverfish 743 4 -605 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:4.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}
execute as @a[scores={player=1..},limit=2] run summon silverfish 751 4 -602 {Tags:["ratKingM","rat"],PersistenceRequired:1,Attributes:[{Name:"generic.maxHealth",Base:1.0},{Name:"generic.movementSpeed",Base:0.0},{Name:"generic.attackKnockback",Base:4.0},{Name:"generic.followRange",Base:40.0},{Name:"generic.attackDamage",Base:0.5}],Health:1}

#set pushable boxes
setblock 743 4 -521 coal_ore
setblock 745 4 -521 coal_ore
setblock 747 4 -521 coal_ore
setblock 749 4 -521 coal_ore
setblock 751 4 -521 coal_ore
setblock 743 4 -519 coal_ore
setblock 745 4 -519 coal_ore
setblock 747 4 -519 coal_ore
setblock 749 4 -519 coal_ore
setblock 751 4 -519 coal_ore

#activate lava traps
fill 742 3 -542 752 3 -504 air replace spruce_slab
setblock 745 3 -541 magma_block
setblock 746 3 -537 magma_block
setblock 749 3 -534 magma_block
setblock 745 3 -530 ladder[facing=south]
setblock 747 3 -530 ladder[facing=south]
setblock 749 3 -530 ladder[facing=south]
#setblock 745 3 -522 ladder[facing=north]
#setblock 749 3 -522 ladder[facing=north]
fill 742 1 -523 742 3 -523 ladder[facing=north]
fill 752 1 -523 752 3 -523 ladder[facing=north]
setblock 744 3 -510 magma_block
setblock 747 3 -509 magma_block
setblock 750 3 -508 magma_block
setblock 752 3 -505 magma_block

#ladder
execute as @a run playsound block.ladder.place master @s ~ ~ ~ 1000
fill 745 4 -363 744 7 -363 ladder[facing=south]
fill 749 4 -364 748 8 -364 ladder[facing=south]